from enum import Enum

import numpy as np
import torch


class Backends(Enum):
    NUMPY = 1
    TORCH = 2


def get_backend(tensor):
    if isinstance(tensor, np.ndarray):
        return Backends.NUMPY
    elif isinstance(tensor, torch.Tensor):
        return Backends.TORCH
    else:
        raise TypeError(f"Unsupported backend for tensor type {type(tensor)}")
