import numpy as np
import torch

from vlab.core import Backends, get_backend


def eye(n, ref):
    backend = get_backend(ref)
    if backend == Backends.NUMPY:
        return np.eye(n, dtype=ref.dtype)
    elif backend == Backends.TORCH:
        return torch.eye(n, dtype=ref.dtype, device=ref.device)
    else:
        raise TypeError(f"Unsupported backend {backend}")


def ones_like(x):
    backend = get_backend(x)
    if backend == Backends.NUMPY:
        return np.ones_like(x)
    elif backend == Backends.TORCH:
        return torch.ones_like(x)
    else:
        raise TypeError(f"Unsupported backend {backend}")
