import numpy as np
import torch

from vlab.core import Backends, get_backend


def matmul(x1, x2):
    backend = get_backend(x1)
    if backend == Backends.NUMPY:
        return np.matmul(x1, x2)
    elif backend == Backends.TORCH:
        return torch.matmul(x1, x2)
    else:
        raise TypeError(f"Unsupported backend {backend}")
